<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:lxslt="http://xml.apache.org/xslt" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" xmlns:java="http://xml.apache.org/xslt/java" extension-element-prefixes="redirect java lxslt ">
<xsl:output method="xml" indent="no"/>
<xsl:param name="vDialog"/>
<xsl:param name="vAgent"/>

<xsl:template match="@sc-role"><xsl:attribute name="role"><xsl:value-of select="."/></xsl:attribute></xsl:template>
	
<xsl:template match="div[contains(@id,'tplMain')]">
  <xsl:variable name="vIsUeMnu" select="count(descendant::scBlock[contains(@class,'ueMnu')])&gt;0"/>
  <xsl:copy>
    <xsl:apply-templates select="@*"/>
    <xsl:if test="$vIsUeMnu"><xsl:attribute name="class"><xsl:value-of select="si($vIsUeMnu,'ueMnuFra ')"/></xsl:attribute></xsl:if>
    <xsl:apply-overlays/>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>
<xsl:template match="resources ">
	<xsl:value-of select="execute(si(not(getEntryBuffer('resources')), initBuffer('resources', java:java.util.HashMap.new())))"/>
	<xsl:value-of select="execute(setEntryBuffer('resources', concat(string(@title),'§',string(@parentstep),'§',string(@parenttitle)), concat(string(@url),'§',.)))"/>
</xsl:template>

<xsl:variable name="vBufJs" select="java:java.lang.StringBuffer.new()"/>
<xsl:overlay match="body" mode="endBodyTags" priority="100"><xsl:if test="java:length($vBufJs) &gt; 0"><script type="text/javascript"><xsl:value-of select="java:toString($vBufJs)"/></script></xsl:if></xsl:overlay>
	

<xsl:template match="alternative"><xsl:apply-templates/></xsl:template>
<xsl:template match="@lookForAlt"><xsl:attribute name="alt"><xsl:value-of select="if(.='', ancestor::alternative/@alt, .)"/></xsl:attribute></xsl:template>	
	

<xsl:overlay match="/">
<xsl:for-each select="//scBasket">
<xsl:variable name="vKey" select="string(@key)"/>
<xsl:variable name="vUnicity" select="java:java.util.HashSet.new()"/>
<xsl:value-of select="execute(java:put($vBasketPool, $vKey, lxslt:nodeset(//scTooltip[@basketKey=$vKey][java:add($vUnicity, string(@itemKey))])))"/> 
</xsl:for-each>	
</xsl:overlay>
<xsl:template match="scBasket">
<xsl:variable name="vClass" select="@widgetClass"/>
<xsl:variable name="vKey" select="string(@key)"/>
<xsl:variable name="vHasElts" select="boolean(java:get($vBasketPool, $vKey))"/>
<xsl:if test="$vHasElts or @suppressIfEmpty = 'no'">
<xsl:choose>
<xsl:when test="scBlock">
<xsl:element name="{returnFirst(scBlock/@tagName, 'div')}">
<xsl:attribute name="class"><xsl:value-of select="concat(@class,' ',$vClass)"/></xsl:attribute>
<xsl:variable name="vCount" select="count(ancestor::scBlock)+1"/>
<xsl:variable name="vMaxHx"><xsl:call-template name="maxHeadingNumber"/></xsl:variable>
<xsl:element name="{concat('h', if($vCount &gt; $vMaxHx, $vMaxHx, $vCount))}">
<xsl:apply-templates select="scBlock/hx/@*"/>
<xsl:apply-overlays select="scBlock/hx/node()"/>
<xsl:apply-templates select="scBlock/hx/node()"/>
</xsl:element>
<xsl:apply-templates select="." mode="scBasketList"/>
</xsl:element>
</xsl:when>
<xsl:when test="scBasketTitle">
<div>
<xsl:attribute name="class"><xsl:value-of select="concat(@class,' ',$vClass)"/></xsl:attribute>
<div>
<xsl:attribute name="class"><xsl:value-of select="addSuffixOnWords($vClass, '_ti')"/></xsl:attribute>
<xsl:apply-templates select="scBasketTitle/node()"/>
</div>
<xsl:apply-templates select="." mode="scBasketList"/>
</div>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates select="." mode="scBasketList"/>
</xsl:otherwise>
</xsl:choose>
</xsl:if>
</xsl:template>
<xsl:template match="scBasket" mode="scBasketList">
<xsl:variable name="vClass" select="@widgetClass"/>
<xsl:variable name="vKey" select="string(@key)"/>
<xsl:variable name="vChiTagName" select="if(@tagName='div','div','li')"/>
<xsl:element name="{@tagName}">
<xsl:choose>
<xsl:when test="scBlock|scBasketTitle">
<xsl:attribute name="class"><xsl:value-of select="addSuffixOnWords($vClass, '_li')"/></xsl:attribute>
<xsl:attribute name="data-titled-basket">true</xsl:attribute>
</xsl:when>
<xsl:otherwise>
<xsl:attribute name="class"><xsl:value-of select="concat(@class,' ',$vClass)"/></xsl:attribute>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="@sort='byTitle'">
<xsl:for-each select="java:get($vBasketPool, $vKey)">
<xsl:sort select="scTooltipTitle" data-type="text"/>
<xsl:apply-templates select="." mode="scBasketItem">
<xsl:with-param name="vClass" select="$vClass"/>
<xsl:with-param name="vChiTagName" select="$vChiTagName"/>
</xsl:apply-templates>
</xsl:for-each>
</xsl:when>
<xsl:when test="@sort='byContent'">
<xsl:for-each select="java:get($vBasketPool, $vKey)">
<xsl:sort select="scTooltipContent" data-type="text"/>
<xsl:apply-templates select="." mode="scBasketItem">
<xsl:with-param name="vClass" select="$vClass"/>
<xsl:with-param name="vChiTagName" select="$vChiTagName"/>
</xsl:apply-templates>
</xsl:for-each>
</xsl:when>
<xsl:otherwise>
<xsl:for-each select="java:get($vBasketPool, $vKey)">
<xsl:apply-templates select="." mode="scBasketItem">
<xsl:with-param name="vClass" select="$vClass"/>
<xsl:with-param name="vChiTagName" select="$vChiTagName"/>
</xsl:apply-templates>
</xsl:for-each>
</xsl:otherwise>
</xsl:choose>
</xsl:element>
</xsl:template>
<xsl:template match="*" mode="scBasketItem">
<xsl:param name="vClass"/>
<xsl:param name="vChiTagName"/>
<xsl:choose>
<xsl:when test="local-name() = 'scTooltip'">
<xsl:variable name="vIdInBskt" select="concat(@basketKey, generate-id(.))"/>
<xsl:element name="{$vChiTagName}">
<xsl:attribute name="class"><xsl:value-of select="addSuffixOnWords($vClass, '_it')"/></xsl:attribute>
<xsl:attribute name="id"><xsl:value-of select="$vIdInBskt"/></xsl:attribute>
<div class="{addSuffixOnWords($vClass, '_itti')}">
<xsl:choose>
<xsl:when test="scTooltipTitle"><xsl:apply-templates select="scTooltipTitle/node()"/></xsl:when>
<xsl:otherwise><xsl:attribute name="style">display:none;</xsl:attribute></xsl:otherwise>
</xsl:choose>
</div>
<div class="{addSuffixOnWords($vClass, '_itco')}">
<xsl:choose>
<xsl:when test="scTooltipContent"><xsl:apply-templates select="scTooltipContent/node()"/></xsl:when>
<xsl:otherwise><xsl:attribute name="style">display:none;</xsl:attribute></xsl:otherwise>
</xsl:choose>
</div>
</xsl:element>		
</xsl:when>
</xsl:choose>
</xsl:template>
	

<xsl:template match="scBlock[@tagName='none']"><xsl:apply-overlays/><xsl:apply-templates/></xsl:template>
<xsl:template match="scBlock"><xsl:element name="{returnFirst(@tagName, 'div')}"><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:element></xsl:template>
<xsl:template match="scBlockTitle"/>
	

<xsl:variable name="vBasketPool" select="java:java.util.HashMap.new()"/>
	
<xsl:overlay match="body" priority="100">
	<xsl:value-of select="execute(java:append($vBufJs, 'tplMgr.init();'))"/>
</xsl:overlay>

<xsl:variable name="vOutputTypeXml" select="false()"/>
	
<xsl:template match="div[contains(@id,'tplRgt')]">
  <xsl:variable name="vArcType" select="returnFirst(substring-after(descendant::scBlock[contains(@class,'arcBk')]/@class,'arcBk'),'noArc')"/>
  <xsl:copy>
    <xsl:apply-templates select="@*"/>
    <xsl:attribute name="class"><xsl:value-of select="concat(@class,' ',$vArcType)"/>Fra</xsl:attribute>
    <xsl:apply-overlays/>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template> 
<xsl:overlay match="head" mode="startHeadTags">
	<meta http-equiv="x-ua-compatible" content="IE=EDGE" />
</xsl:overlay>

<xsl:template match="crossRef"/>
<xsl:overlay match="*[crossRef]" priority="1">
<xsl:variable name="vId" select="java:ensureIdOnCurrentResultElt($vDialog, string(crossRef[@prefId]/@prefId))"/>
<xsl:for-each select="crossRef/entry"><xsl:value-of select="java:com.scenari.m.ge.generator.web.CrossRefEntry.addEntry($vDialog, $vId, @keyRef, @value)"/></xsl:for-each>
</xsl:overlay>
	

<xsl:template match="/"><xsl:apply-overlays/><xsl:apply-templates select="node()"/></xsl:template>
<xsl:template match="head">
<xsl:copy>
<xsl:apply-templates select="@*"/>
<xsl:apply-overlays select="." mode="startHeadTags"/>
<xsl:apply-overlays/>
<xsl:apply-templates/>
<xsl:apply-overlays select="." mode="endHeadTags"/>
</xsl:copy>
</xsl:template>
<xsl:template match="body">
<xsl:copy>
<xsl:apply-templates select="@*"/>
<xsl:apply-overlays select="." mode="startBodyTags"/>
<xsl:apply-overlays select="." mode="startTags"/>
<xsl:apply-overlays/>
<xsl:apply-templates/>
<xsl:apply-overlays select="." mode="endTags"/>
<xsl:apply-overlays select="." mode="endBodyTags"/>
</xsl:copy>
</xsl:template>
<xsl:template match="zoneContent"><xsl:apply-overlays/><xsl:apply-templates/></xsl:template>
<xsl:template match="ifText">
<xsl:variable name="vRoot" select="if(@root='firstChild', */*[1], if(@root='lastChild', */*[last()], .))"/>
<xsl:if test="$vRoot/descendant::text()[string-length(normalize-space())&gt;0 and not(./ancestor::ifTextIgnore)] | $vRoot/descendant::img[not(./ancestor::ifTextIgnore)] | $vRoot/descendant::object[not(./ancestor::ifTextIgnore)] | $vRoot/descendant::input[not(./ancestor::ifTextIgnore)] | $vRoot/descendant::iframe[not(./ancestor::ifTextIgnore)]"><xsl:apply-templates/></xsl:if>
</xsl:template>
<xsl:template match="ifTextIgnore">
<xsl:apply-templates/>
</xsl:template>
<xsl:template name="maxHeadingNumber">6</xsl:template>
<xsl:template match="hx"><xsl:variable name="vCount" select="count(ancestor::scBlock)"/><xsl:variable name="vMaxHx"><xsl:call-template name="maxHeadingNumber"/></xsl:variable><xsl:element name="{concat('h', if($vCount &gt; $vMaxHx, $vMaxHx, $vCount))}"><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:element></xsl:template>
<xsl:template match="addAttribute">
<xsl:variable name="vAttCo"><xsl:choose><xsl:when test="@filter='textOnly'"><xsl:value-of select="normalize-space(.)"/></xsl:when><xsl:otherwise><redirect:serialize omit-xml-declaration="yes"><xsl:value-of select="."/></redirect:serialize></xsl:otherwise></xsl:choose></xsl:variable>
<xsl:choose>
<xsl:when test="@name = 'lookForAlt'">
<xsl:attribute name="alt"><xsl:value-of select="if(string($vAttCo)='', ancestor::alternative/@alt, $vAttCo)" disable-output-escaping="yes"/></xsl:attribute>
</xsl:when>
<xsl:otherwise>
<xsl:attribute name="{@name}"><xsl:value-of select="$vAttCo" disable-output-escaping="yes"/></xsl:attribute>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
<xsl:template match="@noLocalOutline"/>
<xsl:template match="@tagName"/>
	
	<xsl:template match="* | processing-instruction() | comment()"><xsl:copy><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:copy></xsl:template>
	<xsl:template match="@* | text()"><xsl:copy/></xsl:template>
</xsl:stylesheet>
