<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:sc="http://www.utc.fr/ics/scenari/v3/core"
    xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive"
    xmlns:op="utc.fr:ics/opale3"
    xmlns:opa="kelis.fr:opa"
    xmlns:xalan="http://xml.apache.org/xalan"
    exclude-result-prefixes="sc sp xalan opa op">

	<xsl:output encoding="UTF-8" method="xml" indent="yes"/>

	<xsl:param name="pCurrentItem"/>
	<xsl:param name="pCurrentItemUri"/>
	
	<xsl:template match="opa:map/sp:node">		
		<xsl:copy>
			<xsl:apply-templates select="node() | @*" />
			<opa:mapNodeM>
				<xsl:variable name="vDocument" select="try(parseXml(resolveSrcPath(@sc:refUri, $pCurrentItem)), 'Warning', concat('Item ', @sc:refUri, ' est en erreur.'))"/>
				<xsl:copy-of select="$vDocument//sp:noClick"/>
			</opa:mapNodeM>
		</xsl:copy>
	</xsl:template>

	<xsl:template match="opa:visualMapLnkCondM">
		<xsl:copy>
			<xsl:variable name="vDocument" select="try(parseXml(resolveSrcPath(parent::sp:node/@sc:refUri, $pCurrentItem)), 'Warning', concat('Item ', @sc:refUri, ' est en erreur.'))"/>
			<xsl:copy-of select="$vDocument//sp:noClick"/>
			<xsl:apply-templates select="node() | @*" />
		</xsl:copy>
	</xsl:template>

	<xsl:template match="node() | @*">
		<xsl:copy>
			<xsl:apply-templates select="node() | @*" />
		</xsl:copy>
	</xsl:template>

</xsl:stylesheet>
