<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sm="http://www.utc.fr/ics/scenari/v3/modeling" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:xalan="http://xml.apache.org/xalan" xmlns:java="http://xml.apache.org/xslt/java" xmlns:opa="kelis.fr:opa" exclude-result-prefixes="sm sc sp xalan java opa">
	<xsl:output method="xml" encoding="UTF-8" indent="no" omit-xml-declaration="yes"/>
	<xsl:param name="vAgent"/>
	<xsl:param name="vDialog"/>
	<xsl:variable select="parseXml(computeStrAgent(concat('@', getIdFromPath(sp:image/@sc:refUri), '_Anav/props')))/props/image" name="vImgProps"/>
	<xsl:variable select="computeStrDialog(concat('@', getIdFromPath(sp:image/@sc:refUri), '_Anav'), 'act:')" name="vImgUri"/>
	<xsl:variable select="$vImgProps/@transformedWidth div $vImgProps/@nativeWidth" name="vRatio"/>
	<xsl:template match="opa:visualMap">
		<xsl:apply-templates select="sp:image"/>
		<map id="map" name="map">
			<xsl:apply-templates select="sp:area"/>
		</map>
		<script type="text/JavaScript">
<xsl:for-each select="sp:area">
				<xsl:for-each select="descendant::opa:visualMapLnkCondM/sp:cond">
					<xsl:if test="opa:condCalc">
						<xsl:value-of select="getContent(gotoSubModel(opa:condCalc/sp:left), 'calc')" disable-output-escaping="yes"/>
					</xsl:if>
				</xsl:for-each>topazeMgr.addArcCnd({id:<xsl:value-of select="count(preceding-sibling::sp:area)"/>
				<xsl:choose>
					<xsl:when test="not(descendant::opa:visualMapLnkCondM/sp:cond)">,nc:true</xsl:when>
					<xsl:otherwise>,cd:[<xsl:for-each select="descendant::opa:visualMapLnkCondM/sp:cond">{<xsl:choose>
								<xsl:when test="opa:condCalc">pl:<xsl:value-of select="getContent(gotoSubModel(opa:condCalc/sp:left), 'initArc')" disable-output-escaping="yes"/>,op:"<xsl:value-of select="opa:condCalc/sp:op"/>",vl:"<xsl:value-of select="opa:condCalc/sp:right"/>"</xsl:when>
								<xsl:when test="opa:condFinished">pl:<xsl:value-of select="getContent(gotoSubModel(opa:condFinished/sp:left), 'initArcFinished')" disable-output-escaping="yes"/>,op:"=",vl:"<xsl:value-of select="opa:condFinished/sp:right"/>"</xsl:when>
								<xsl:when test="opa:condSeen">pl:<xsl:value-of select="getContent(gotoSubModel(opa:condSeen/sp:left), 'initArcStatus')" disable-output-escaping="yes"/>,op:"=",vl:"<xsl:value-of select="opa:condSeen/sp:right"/>"</xsl:when>
							</xsl:choose>}<xsl:if test="following-sibling::sp:cond">,</xsl:if></xsl:for-each>]</xsl:otherwise>
				</xsl:choose>});</xsl:for-each>
topazeMgr.initArc = topazeMgr.initArcChoose;
		</script>
	</xsl:template>
	<xsl:template match="sp:image">
		<img src="{$vImgUri}" usemap="#map" height="{$vImgProps/@transformedHeight}" width="{$vImgProps/@transformedWidth}" class="visualMap_img" alt=""/>
		<!--<xsl:value-of select="getFullTitleText(gotoSubModel())" disable-output-escaping="yes"/>
		<xsl:value-of select="getContent(gotoMeta(gotoSubModel()),'info')" disable-output-escaping="yes"/>-->
		<xsl:copy-of select="parseXml(getContent(gotoSubModel(),'credits'))"/>
	</xsl:template>
	<xsl:template match="sp:area">
		<xsl:variable name="vTxt" select="getContent(gotoSubModel(),'txt')"/>
		<xsl:variable name="vLnk" select="getUrl(gotoSubModel(),'lnk')"/>
		<xsl:variable name="vClick">
			<xsl:if test="not(opa:nodeLink/sp:node/opa:visualMapLnkCondM/sp:noClick = 'no')">enabled_click</xsl:if>
		</xsl:variable>
		<xsl:variable name="vCoords" select="java:eu.scenari.modeling.util.Math.coordsRound(java:eu.scenari.modeling.util.Math.coordsRatio(opa:areaMeta/sp:geo/sp:coords/text(),$vRatio))"/>
		<xsl:choose>
			<xsl:when test="$vTxt">
				<scTooltip trigger="onmouseover" class="scMapTooltip">
					<scTooltipContent>
						<div>
							<xsl:value-of select="$vTxt" disable-output-escaping="yes"/>
						</div>
					</scTooltipContent>
					<area class="enabled_entry {$vClick}" shape="{opa:areaMeta/sp:geo/sp:shape}" coords="{$vCoords}" target="mainFrame" href="{$vLnk}"/>
				</scTooltip>
			</xsl:when>
			<xsl:otherwise>
				<area class="enabled_entry {$vClick}" shape="{opa:areaMeta/sp:geo/sp:shape}" coords="{$vCoords}" target="mainFrame" href="{$vLnk}"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>